/*
T-SQL-Abfragen fr Microsoft SQL-Server 2022
Kontakt per E-Mail: info@it-angermann.de
Letzte Aktualisierung:  23 Mrz 2024.
Dirk Angermann
https://it-angermann.de
*/

-- Gesucht sind die Namen der Lieferanten, deren Status und der
-- Firmensitz. Die Ausgabe soll nach dem Firmensitz in absteigender
-- Reihenfolge erfolgen.
SELECT 
	LName AS 'Lieferantenname'
	,Status
	,LStadt AS 'Firmensitz'
FROM dbo.Lieferant
ORDER BY LName DESC;

-- Gesucht sind die Namen der Lieferanten, deren Status und der
-- Firmensitz. Die Ausgabe soll nach dem Firmensitz in aufsteigender
-- Reihenfolge erfolgen.
SELECT 
	LName AS 'Lieferantenname'
	,Status
	,LStadt AS 'Firmensitz'
FROM dbo.Lieferant
ORDER BY LName ASC;

SELECT
	LName AS 'Lieferantenname'
	,[Status]
	,LStadt AS 'Firmensitz'
FROM dbo.Lieferant
ORDER BY 'Lieferantenname' ASC;

SELECT
	LName AS 'Lieferantenname'
	,[Status]
	,LStadt AS 'Firmensitz'
FROM dbo.Lieferant
ORDER BY 1 DESC;

-- Gesucht sind die drei besten Lieferungen mit den hchsten 
-- Liefermengen.
SELECT TOP 3
	LNr AS 'Lieferantennummer'
	,LDatum AS 'Lieferdatum'
	,LMenge AS 'Liefermenge'
FROM dbo.Lieferung
ORDER BY LMenge DESC;

-- Gesucht sind die vier besten Lieferungen mit den hchsten
-- Liefermengen.
SELECT TOP 4 
	LNr AS 'Lieferantennummer'
	,LDatum AS 'Lieferdatum'
	,LMenge AS 'Liefermenge'
FROM dbo.Lieferung
ORDER BY LMenge DESC;

-- Gesucht sind die vier besten Lieferungen mit den hchsten Liefermengen
-- und die eventuell weiteren vierten Pltze. (Duplikate)
SELECT TOP 4 WITH TIES 
	LNr AS 'Lieferantennummer'
	,LDatum AS 'Lieferdatum'
	,LMenge AS 'Liefermenge'
FROM dbo.Lieferung
ORDER BY LMenge DESC;

-- Gesucht sind die ersten 50% aller Lieferungen.
SELECT TOP 50 PERCENT
	LNr AS 'Lieferantennummer'
	,LDatum AS 'Lieferdatum'
	,LMenge AS 'Liefermenge'
FROM dbo.Lieferung
ORDER BY LMenge DESC;

-- Gesucht sind die drei besten Lieferungen mit den hchsten Liefermengen.
-- Das Ergebnis hnelt TOP 3
SELECT
	LNr AS 'Lieferantennummer'
	,LDatum AS 'Lieferdatum'
	,LMenge AS 'Liefermenge'
FROM dbo.Lieferung
ORDER BY LMenge DESC
OFFSET 0 ROW FETCH FIRST 3 ROW ONLY; -- ROW/ROWS identisch
-- OFFSET 0 ROWS FETCH NEXT 3 ROWS ONLY; -- FIRST/NEXT identisch

-- Gesucht sind, bezogen auf die obere Abfrage, die Folgepltze nach 
-- Platz 3.(Das Ergebnis zeigt die nachfolgenden Pltze (4-12) an.)
SELECT
	LNr AS 'Lieferantennummer'
	,LDatum AS 'Lieferdatum'
	,LMenge AS 'Liefermenge'
FROM dbo.Lieferung
ORDER BY LMenge DESC
OFFSET 3 ROWS FETCH FIRST 9 ROWS ONLY;
-- OFFSET 3 ROW; -- gibt alle Zeilen aus

