/*
T-SQL-Abfragen fr Microsoft SQL-Server 2022
Kontakt per E-Mail: info@it-angermann.de
Letzte Aktualisierung:  23 Mrz 2024.
Dirk Angermann
https://it-angermann.de
*/

SELECT NEWID() AS 'UNIQUEIDENTIFFER';
go


DECLARE @myTINYINT TINYINT = 25;
DECLARE @MyINT INT = 9999;
SELECT @myTINYINT +  @MyINT AS 'Ergebnis';
go


DECLARE @myCHAR CHAR(5) = 6;
DECLARE @MyINT INT = 1;
SELECT @myCHAR +  @MyINT AS 'Ergebnis';
go


DECLARE @myCHAR CHAR(5) = 'sechs';
DECLARE @MyINT INT = 1;
SELECT @myCHAR +  @MyINT AS 'Ergebnis';
go

USE db_Test;
go

SELECT
	LName AS 'Name des Lieferanten'
FROM dbo.Lieferant
WHERE LName = 'Schmidt'
go


SELECT
	LName AS 'Name des Lieferanten'
FROM dbo.Lieferant
WHERE LName COLLATE Latin1_General_CS_AS = 'schmidt'
go


SELECT
	LName + ', ' + LStadt AS 'Zwei Werte in einer Spalte'
FROM dbo.Lieferant;
go


SELECT
	LName + ', ' + [Status] AS 'Zwei Werte in einer Spalte'
FROM dbo.Lieferant;
go


SELECT
	CONCAT(LName, ', ', [Status]) AS 'Zwei Werte in einer Spalte'
FROM dbo.Lieferant;
go


SELECT
	LNr AS 'Lieferant'
	,ANr AS 'Artikel'
	,LMenge AS 'Liefermenge'
	,FORMAT(LDatum, 'dd/MM/yyyy', 'de-DE' ) AS 'Lieferdatum'
	,FORMAT(LDatum, 'dddd, dd. MMM yyyy', 'de-DE' ) AS 'Lieferdatum'
FROM dbo.Lieferung;
go

SELECT 
	RIGHT(AName,3) AS 'Ende'
	, LEFT(AStadt,4) AS 'Anfang'
FROM dbo.Artikel;
go

SELECT 
	SUBSTRING(LName, 1, 1) AS 'Abkrzung'
	,LName AS 'Name'
FROM dbo.Lieferant;
go

SELECT 
	STUFF(LName, 2, 3, 'abc')  AS 'Kauderwelsch'
FROM dbo.Lieferant;
go

SELECT 
	LEN(LName) AS 'Lnge'
	, LName AS 'Lieferantenname'
FROM dbo.Lieferant
WHERE LStadt = 'Hamburg'
go

SELECT 
	UPPER(LName) AS 'Gro'
	,LOWER(LStadt) AS 'Klein'
FROM dbo.Lieferant;
go

SELECT 
	REVERSE(LName) AS 'Rckwrts' 
FROM dbo.Lieferant;
go

SELECT 
	REPLICATE(LName, 5) AS 'NameNameNameNameName'
FROM dbo.Lieferant;
go

SELECT REPLACE('Microsoft SQL Server Version 16','Version 16','2022');
go

SELECT DISTINCT 
	LNr AS 'Lieferantennummer'
FROM dbo.Lieferung
WHERE LDatum BETWEEN '20190701' AND '20190806';

DECLARE @date DATETIME = '20230811';
SELECT @date AS 'Datum';

SELECT
	LNr AS 'Lieferant'
	,ANr AS 'Artikel'
	,LMenge AS 'Liefermenge'
	,LDatum AS 'Lieferdatum'
FROM dbo.Lieferung
WHERE LDatum > '20190801';

SELECT GETDATE() AS 'Aktuelles Datum';

SELECT SYSDATETIME() AS 'Aktuelles Datum';

SELECT SYSDATETIMEOFFSET();

-- Welches Datum war heute vor 351 Tagen?
SELECT DATEADD(dd,-351, SYSDATETIME());

-- Welcher Tag war heute vor 500 Jahren?
SELECT DATEADD(yy,-500,SYSDATETIME());

-- Eine Berechnung, seit wie viel Tagen man auf der Welt ist
SELECT DATEDIFF(dd,'19770811', SYSDATETIME());
-- Vor wie vielen Jahren und Monaten fanden die Lieferungen statt?
SELECT
	LNr AS 'Lieferant'
	,ANr AS 'Artikel'
	,LMenge AS 'Menge'
	,LDatum AS 'Datum'
	,DATEDIFF(mm,LDatum,SYSDATETIME())/12 AS 'Vor Jahren ...'
	,DATEDIFF(mm,LDatum,SYSDATETIME())%12 AS '... und Monaten.'
FROM dbo.Lieferung 
WHERE LNr = 'L01';

-- Gibt den momentanen Monat zurck.
SELECT DATEPART(mm, SYSDATETIME());

-- Gibt den momentanen Monat zurck.
SELECT DATENAME(mm, SYSDATETIME());

SELECT EOMONTH('20230811') AS 'EndOfMonth';

