/*
T-SQL-Abfragen fr Microsoft SQL-Server 2022
Kontakt per E-Mail: info@it-angermann.de
Letzte Aktualisierung:  23 Mrz 2024.
Dirk Angermann
https://it-angermann.de
*/

USE db_Test;
go

SELECT
	LNr AS 'Lieferant'
	,ANr AS 'Artikel'
	,LMenge AS 'Liefermenge'
	,YEAR(LDatum) AS 'Jahr'
	,MONTH(LDatum) AS 'Monat'
FROM dbo.Lieferung;
go

SELECT ABS(-1.0), ABS(0.0), ABS(1.0);
go

SELECT DB_NAME() AS 'Aktuelle Datenbank';
go

SELECT 
	COUNT(*) AS 'Anzahl der Datenstze'
	,MIN(LMenge) AS 'Kleinster Wert'
	,MAX(LMenge) AS 'Grter Wert'
	,SUM(LMenge) AS 'Summe aller Artikel'
FROM dbo.Lieferung;
go

SELECT 
	LNr AS 'Name des Lieferanten'
	,ANr AS 'Artikelname'
    ,LMenge 'gelieferte Menge'
	,RANK() OVER (ORDER BY LMenge DESC) AS 'RANK'
FROM dbo.Lieferung;
go

SELECT
	Name 
	,SN AS 'Nachname'
	,ST AS 'Bundesland'
FROM OPENQUERY(ADSI,
 'SELECT Name, SN, ST
  FROM ''LDAP://DC/DC=SQLDev,DC=de''
  WHERE objectCategory = ''Person'' AND objectClass = ''user''');
go

SELECT CAST('100' AS INT) AS 'Jetzt eine ganze Zahl.'
go

SELECT CAST(100 AS CHAR(1)) AS 'Ein Versuch ...'
go

SELECT CAST(SYSDATETIME() AS INT);
go

SELECT CONVERT(CHAR(10),SYSDATETIME(),104) AS 'Aktuelles Datum';
go

SELECT CONVERT(CHAR(8),SYSDATETIME(),108) AS 'Aktuelle Uhrzeit';
go

USE db_Test;
go

SELECT
	LNr AS 'Lieferantennummer'
	,Anr AS 'Artikelnummer'
	,LMenge AS 'gelieferte Menge'
	,CONVERT(CHAR(10),LDatum,104) AS 'Lieferdatum'
FROM dbo.Lieferung;
go

SELECT PARSE('11/08/2023' AS DATETIME2 USING 'en-US') AS 'Ergebnis';
go

SELECT PARSE('345,98' AS MONEY USING 'de-DE') AS 'Ergebnis';
go

SELECT CONVERT(DATETIME2, '20230231');
go

SELECT CONVERT(INT, 'A100.000') AS 'ganze Zahl';
go

SELECT TRY_CONVERT(INT, 'A100.000') AS 'ganze Zahl';
go

SELECT TRY_PARSE('Freitag, 11 August 2023' AS DATE USING 'en-US')
go

SELECT
	LNr AS 'Nummer'
	,LName AS 'Name'
	,[Status]
	,LStadt AS 'Firmensitz'
FROM dbo.Lieferant
WHERE ISNUMERIC([Status]) = 1;
go

SELECT
	LNr AS 'Nummer'
	,LName AS 'Name'
	,[Status]
	,LStadt AS 'Firmensitz'
FROM dbo.Lieferant
WHERE ISNUMERIC([Status]) = 0;
go

SELECT
	LMenge AS 'gelieferte Menge'
	,IIF(LMenge <= 200, 'niedrig','hoch') AS 'Wertung'
FROM dbo.Lieferung;
go

SELECT CHOOSE(3, 'Mo','Die','Mi','Do','Fr','Sa','So');
go

SELECT CHOOSE(8, 'Mo','Die','Mi','Do','Fr','Sa','So');
go

INSERT INTO dbo.Artikel VALUES ('A07','Splint',NULL,500,'Hamburg',1000);
go

SELECT
	Anr AS 'Artikelnummer'
	,Farbe
	,ISNULL(Farbe,'hmm..') AS 'Bemerkung'
	,Amenge AS 'Lagermenge'
FROM dbo.Artikel;
go

SELECT
	ANr AS 'Artikelnummer'
	,Farbe
	,COALESCE(Farbe,'hmm..') AS 'Bemerkung'
	,AMenge AS 'Lagermenge'
FROM dbo.Artikel;
go