/*
T-SQL-Abfragen fr Microsoft SQL-Server 2022
Kontakt per E-Mail: info@it-angermann.de
Letzte Aktualisierung:  23 Mrz 2024.
Dirk Angermann
https://it-angermann.de
*/

-- Nummern, Namen und Wohnorte der Hamburger Lieferanten sowie 
-- Nummern, Namen und Lagerorte der Artikel, die in Hamburg lagern.
SELECT 
	LNr AS 'Nummer'
	,LName AS 'Namen'
	,LStadt AS 'Ort'
FROM dbo.Lieferant
WHERE LStadt = 'Hamburg'
UNION
SELECT
	ANr
	,AName
	,AStadt
FROM dbo.Artikel
WHERE AStadt = 'Hamburg';

-- Nummern aller Artikel, die in Ludwigshafen gelagert werden bzw. von 
-- Ludwigshafener Lieferanten geliefert worden sind. Aufsteigend
-- angeordnet.
SELECT 
	ANr
FROM dbo.Artikel
WHERE AStadt = 'Ludwigshafen'
UNION
SELECT 
	ANr
FROM dbo.Lieferant AS a INNER JOIN dbo.Lieferung AS c ON a.LNr = c.LNr
WHERE LStadt = 'Ludwigshafen'
ORDER BY ANr;

SELECT
	LNr AS 'Nummer'
FROM dbo.Lieferant
INTERSECT
SELECT
	LNr
FROM dbo.Lieferung;

SELECT
	LNr AS 'Nummer'
FROM dbo.Lieferant
EXCEPT
SELECT
	LNr
FROM dbo.Lieferung;