/*
T-SQL-Abfragen fr Microsoft SQL-Server 2022
Kontakt per E-Mail: info@it-angermann.de
Letzte Aktualisierung:  23 Mrz 2024.
Dirk Angermann
https://it-angermann.de
*/

SELECT 
	LNr AS 'Name des Lieferanten'
	,ANr AS 'Artikelname'
	,LMenge 'gelieferte Menge'
	,ROW_NUMBER() OVER (ORDER BY LMenge DESC) AS 'ROW_NUMBER'
FROM dbo.Lieferung;

SELECT 
	LNr AS 'Name des Lieferanten'
	,ANr AS 'Artikelname'
	,LMenge 'gelieferte Menge'
	,ROW_NUMBER() OVER (PARTITION BY LNr ORDER BY LMenge DESC) AS 'ROW_NUMBER'
FROM dbo.Lieferung;

SELECT DISTINCT 
	LNr AS 'Nummer Lieferant'
	,MIN(LMenge) OVER (PARTITION BY LNr) AS 'MIN'
	,MAX(LMenge) OVER (PARTITION BY LNr) AS 'MAX'
	,SUM(LMenge) OVER (PARTITION BY LNr) AS 'SUM'
	,COUNT(LMenge) OVER (PARTITION BY LNr) AS 'COUNT'
FROM dbo.Lieferung;

-- ROW_NUMBER
SELECT 
	LNr AS 'Name des Lieferanten'
	,ANr AS 'Artikelname'
	,LMenge 'gelieferte Menge'
	,ROW_NUMBER() OVER (ORDER BY LMenge DESC) AS 'ROW_NUMBER'
FROM dbo.Lieferung;

-- ROW_NUMBER mit Partitionierung
SELECT 
	LNr AS 'Name des Lieferanten'
	,ANr AS 'Artikelname'
	,LMenge 'gelieferte Menge'
	,ROW_NUMBER() OVER (PARTITION BY LNr ORDER BY LMenge DESC) AS 'ROW_NUMBER'
FROM dbo.Lieferung;

-- RANK
SELECT 
	LNr AS 'Name des Lieferanten'
	,ANr AS 'Artikelname'
	,LMenge 'gelieferte Menge'
	,RANK() OVER (ORDER BY LMenge DESC) AS 'RANK'
FROM dbo.Lieferung;

-- RANK mit Partitionierung
SELECT 
	LNr AS 'Name des Lieferanten'
	,ANr AS 'Artikelname'
	,LMenge 'gelieferte Menge'
	,RANK() OVER (PARTITION BY LNr ORDER BY LMenge DESC) AS 'RANK'
FROM dbo.Lieferung;

-- DENSE_RANK
SELECT 
		LNr AS 'Name des Lieferanten'
		,ANr AS 'Artikelname'
		,LMenge 'gelieferte Menge'
		,DENSE_RANK() OVER (ORDER BY LMenge DESC) AS 'DENSE_RANK'
FROM dbo.Lieferung;

-- DANSE_RANK mit Partitionierung
SELECT 
	LNr AS 'Name des Lieferanten'
	,ANr AS 'Artikelname'
	,LMenge 'gelieferte Menge'
	,DENSE_RANK() OVER (PARTITION BY LNr ORDER BY LMenge DESC) 'DENSE_RANK'
FROM dbo.Lieferung;

-- NTILE
SELECT 
	LNr AS 'Name des Lieferanten'
	,ANr AS 'Artikelname'
	,LMenge 'gelieferte Menge'
	,NTILE(4) OVER (ORDER BY LMenge DESC) AS 'NTILE'
FROM dbo.Lieferung;

-- NTILE mit Partitionierung
SELECT 
	LNr AS 'Name des Lieferanten'
	,ANr AS 'Artikelname'
	,LMenge 'gelieferte Menge'
	,NTILE(4) OVER (PARTITION BY LNr ORDER BY LMenge DESC) AS 'NTILE'
FROM dbo.Lieferung;


SELECT
	LNr AS 'Lieferantennummer'
	,LDatum AS 'Lieferdatum'
	,LMenge AS 'Liefermenge'
	,LAG(LMenge,1,0) OVER (ORDER BY LDatum ASC) AS 'Vorherige Lieferung'
FROM dbo.Lieferung
WHERE LNr = 'L01';

SELECT
	LNr AS 'Lieferantennummer'
	,LDatum AS 'Lieferdatum'
	,LMenge AS 'Liefermenge'
	,LEAD(LMenge,1,0) OVER (ORDER BY LDatum ASC ) AS 'Nachf. Lieferung'
FROM dbo.Lieferung
WHERE LNr = 'L01';
