/*
T-SQL-Abfragen fr Microsoft SQL-Server 2022
Kontakt per E-Mail: info@it-angermann.de
Letzte Aktualisierung:  23 Mrz 2024.
Dirk Angermann
https://it-angermann.de
*/

/* Tabelle erstellen */
CREATE TABLE #Staging
(
 Liefersystem CHAR(1)
 ,Stichtag DATE
 ,Anzahl INT
);

/* Tabelle mit Daten befllen */
INSERT INTO #Staging VALUES 
 ('A', '20180120', 200),
 ('B', '20180120', 100),
 ('C', '20180120', 300),
 ('A', '20180121', 400),
 ('B', '20180121', 500),
 ('C', '20180121', 600),
 ('A', '20180122', 700),
 ('B', '20180122', 800),
 ('C', '20180122', 900),
 ('A', '20180123', 100),
 ('B', '20180123', 200),
 ('C', '20180123', 300),
 ('A', '20180124', 400),
 ('B', '20180124', 500),
 ('C', '20180124', 600);

-- normale SELECT-Anweisung
SELECT
	Liefersystem
	,Stichtag
	,Anzahl
FROM dbo.#Staging;

-- Daten umwandeln
SELECT Stichtag, A, B, C 
FROM #Staging
PIVOT (SUM(Anzahl) FOR Liefersystem in ([A], [B], [C])) AS pvt
ORDER BY Stichtag DESC;

/* Tabelle erstellen */
CREATE Table #Person 
(
 [Name] VARCHAR(100) NOT NULL
 ,Mobil VARCHAR(30) NULL
 ,Arbeit VARCHAR(30) NULL
 ,Privat VARCHAR(30) NULL
);

/* Beispieldaten einfgen */
INSERT INTO #Person VALUES ('Karl Klammer', '0151 111 111 111', '069 111 111 111', NULL),
						   ('Graf Zahl', '0152 222 222 222', NULL, '0661 222 222 222'),
						   ('Max Muster', NULL, '069 333 333 333', '0661 333 333 333');
SELECT
	[Name]
	 ,Mobil
	,Arbeit
	,Privat
FROM dbo.#Person;

/* Daten umwandeln */
SELECT *
FROM #Person
UNPIVOT
( Nummer FOR Typ IN ([Mobil], [Arbeit], [Privat])) AS up

SELECT
	LNr AS 'Lieferant'
	,ANr AS 'Artikel'
	,SUM(LMenge) AS 'Summe'
FROM dbo.Lieferung
GROUP BY LNr, Anr
UNION ALL
SELECT
	NULL
	,ANr
	,SUM(LMenge) AS 'Summe'
FROM dbo.Lieferung
GROUP BY Anr
UNION ALL
SELECT
	LNr
	,NULL
	,SUM(LMenge) AS 'Summe'
FROM dbo.Lieferung
GROUP BY LNr
UNION ALL
SELECT
	NULL
	,NULL
	,SUM(LMenge) AS 'Summe'
FROM dbo.Lieferung;

SELECT
	LNr
	,ANr
	,SUM(LMenge) AS 'Summe'
FROM Lieferung
GROUP BY GROUPING SETS
 (
	 (LNr, ANr)
	,(ANr)
	,(LNr)
	,()
 );

SELECT 
	LNr AS 'Lieferantennummer'
	,ANr AS 'Artikelnummer'
	,SUM(LMenge) 'Summen'
FROM dbo.Lieferung
GROUP BY LNr, ANr WITH CUBE;

SELECT
	LNr AS 'Lieferantennummer'
	,ANr AS 'Artikelnummer'
	,SUM(LMenge) AS 'Summe'
FROM Lieferung
GROUP BY GROUPING SETS
 (
	 (LNr, ANr)
	 ,(ANr)
	 ,(LNr)
	 ,()
 );

SELECT 
	LNr AS 'Lieferantennummer'
	,ANr AS 'Artikelnummer'
	,SUM(LMenge) 'Summen'
FROM dbo.Lieferung
GROUP BY LNr, ANr WITH ROLLUP;

SELECT
	LNr AS 'Lieferantennummer'
	,ANr AS 'Artikelnummer'
	,SUM(LMenge) AS 'Summe'
FROM Lieferung
GROUP BY GROUPING SETS
 (
	 (LNr, ANr)
	 ,(LNr)
	 ,()
 );