/*
T-SQL-Abfragen fr Microsoft SQL-Server 2022
Kontakt per E-Mail: info@it-angermann.de
Letzte Aktualisierung:  23 Mrz 2024.
Dirk Angermann
https://it-angermann.de
*/

USE master;
go 

SELECT 
	name
	,database_id
	,user_access
	,state_desc
	,recovery_model
FROM sys.databases;

USE db_Test;
go

SELECT 
	name
	,object_id
	,schema_id
	,type
	,type_desc
FROM sys.tables;

SELECT
	TABLE_CATALOG
	,TABLE_SCHEMA
	,TABLE_NAME
	,TABLE_TYPE
FROM INFORMATION_SCHEMA.TABLES;

SELECT @@SERVERNAME AS 'Instanzname';

SELECT @@VERSION AS 'Installierte Version';

SELECT SERVERPROPERTY('ProductVersion') AS 'Version';

SELECT SERVERPROPERTY('Collation') AS 'Sortierung';

EXEC sys.sp_databases;

EXEC sys.sp_help @objname = 'Lieferant';

EXEC sys.sp_tables 'Lieferung', 'dbo';

EXEC sys.sp_tables @table_name ='Lieferung', @table_owner = 'dbo';

EXEC sys.sp_helplanguage;

SELECT
	session_id
	,login_name
	,program_name
FROM sys.dm_exec_sessions
WHERE is_user_process = 1;

SELECT
	referencing_schema_name
	,referencing_entity_name
	,referencing_class_desc
FROM sys.dm_sql_referencing_entities ('dbo.Lieferant','OBJECT');

