/*
T-SQL-Abfragen fr Microsoft SQL-Server 2022
Kontakt per E-Mail: info@it-angermann.de
Letzte Aktualisierung:  23 Mrz 2024.
Dirk Angermann
https://it-angermann.de
*/

USE db_Test;
go

-- Erstellen der gespeicherten Prozedur
CREATE PROC dbo.usp_Artikel
AS
SELECT 
	ANr AS 'Artikelnummer' 
	,AName AS 'Artikelname'
	,AStadt AS 'Lagerort' 
	,AMenge AS 'Lagerbestand'
FROM dbo.Artikel;
go

-- Ausfhren der gespeicherten Prozedur
EXEC dbo.usp_Artikel;
go

-- Erstellen der gespeicherten Prozedur
ALTER PROC dbo.usp_Artikel
AS
SELECT 
	ANr AS 'Artikelnummer' 
	,Aname AS 'Artikelname'
	,Astadt AS 'Lagerort' 
	,Amenge AS 'Lagerbestand'
FROM dbo.Artikel
WHERE Astadt = 'Hamburg';
go

-- Ausfhren der gespeicherten Prozedur
EXEC dbo.usp_Artikel;
go

-- Erstellen der Prozedur mit Eingabeparametern (Variablenbergabe)
CREATE PROC dbo.usp_LStadt @ort VARCHAR(20)
AS
	SELECT 
	LNr 'Lieferantennummer'
	,LName 'Name des Lieferanten'
	,Status 
	,LStadt 'Lieferantenstadt'
FROM dbo.Lieferant
WHERE LStadt = @ort;
go

-- Ausfhren der gespeicherten Prozedur
EXEC dbo.usp_LStadt 'Hamburg';

-- Erneutes Ausfhren der gespeicherten Prozedur
EXEC dbo.usp_LStadt 'Aachen';

DECLARE @sqlZeichenfolge AS VARCHAR(100)
SET @sqlZeichenfolge = 'SELECT ANr, '+' AName '+' FROM dbo.Artikel;'
EXEC (@sqlZeichenfolge);

DECLARE @sqlCode AS NVARCHAR(255) = 'SELECT GETDATE() AS Datum_Uhrzeit';
EXEC sp_executesql @statment = @sqlCode;

