/*
T-SQL-Abfragen fr Microsoft SQL-Server 2022
Kontakt per E-Mail: info@it-angermann.de
Letzte Aktualisierung:  23 Mrz 2024.
Dirk Angermann
https://it-angermann.de
*/

DECLARE @wert1 INT = 30
		,@wert2 VARCHAR(20) = 'Angermann'
		,@wert3 DATETIME = '20230331'

SELECT 
	@wert1 AS 'Spalte 1'
	,@wert2 AS 'Spalte 2'
	,@wert3 AS 'Spalte 3'

SET @wert3 = @wert3 + @wert1

SELECT @wert3 AS 'Ergebnis'

DECLARE @wert1 INT
go
SET @wert1 = 1234
go

DECLARE @LNr CHAR(3), @LName VARCHAR(15), @LStadt VARCHAR(25)
SET @LNr = 'L03'
SELECT @LName = LName, @LStadt = LStadt
FROM dbo.Lieferant
WHERE LNr = @LNr
PRINT 'Der Name lautet : ' + @LName
PRINT 'Der Lieferant wohnt in: ' + @LStadt; 

CREATE SYNONYM MeineArtikel
FOR db_Test.dbo.Artikel;
go
SELECT 
	ANr AS 'Artikelnummer'
	,AName AS 'Artikelname'
FROM MeineArtikel;
go

USE db_Test;
go

IF OBJECT_ID ('dbo.Lieferant') IS NOT NULL -- dieses Objekt existiert BEGIN
PRINT 'Das Objekt existiert!'
END

USE db_Test;
go

IF OBJECT_ID ('dbo.TSQL') IS NOT NULL -- dieses Objekt existiert nicht 
BEGIN
	PRINT 'Das Objekt existiert!'
END
ELSE
BEGIN
	PRINT 'Das Objekt existiert nicht!'
END;

-- Realisierung eines Zhlers (Counter) mit einer WHILE-Schleife
DECLARE @counter INT = 0
WHILE @counter < 10
BEGIN
	SET @counter = @counter + 1
	PRINT @counter
END
PRINT 'Schleife beendet';

-- Realisierung eines Zhlers (Counter) mit einer WHILE-Schleife,_
-- die aber nach dem ersten Durchlauf abgebrochen wird.
DECLARE @counter INT = 0
WHILE @counter < 10
BEGIN
	SET @counter = @counter + 1
	PRINT @counter
	BREAK
END
PRINT 'Schleife beendet';

-- Realisierung eines Zhlers (Counter) mit einer WHILE-Schleife.
-- Der vierte Durchlauf soll nicht ausgedruckt werden.
DECLARE @counter INT = 0
WHILE @counter < 10
BEGIN
	SET @counter = @counter + 1
	IF @counter=4
	CONTINUE
	ELSE -- ist hier optional, kann auch weggelassen werden
	PRINT @counter
END
PRINT 'Schleife beendet';

